Index: libabac/abac.h
===================================================================
--- libabac/abac.h	(revision 11e3eb75ff772401dd8d6b1639738ecf7a93ef96)
+++ libabac/abac.h	(revision 461541aae6382bb58dfb3c4a1679d2d48e8f9e64)
@@ -2,9 +2,19 @@
 #define __ABAC_H__
 
-#include <abac_common.h>
+#include <time.h>  // for struct tm 
+#include <stdio.h> // for FILE
+#include "abac_list.h"
 
 typedef struct _abac_context_t abac_context_t;
 typedef struct _abac_credential_t abac_credential_t;
 typedef struct _abac_role_t abac_role_t;
+
+typedef struct _abac_id_t abac_id_t;
+typedef struct _abac_attribute_t abac_attribute_t;
+
+typedef struct _abac_chunk_t {
+    unsigned char *ptr;
+    int len;
+} abac_chunk_t;
 
 /*
@@ -69,4 +79,148 @@
 
 /*
+ * Operations on ID
+ */
+// create an ID from an X.509 certificate
+abac_id_t *abac_id_from_file(char *);
+
+// create an ID from a X.509 certificate PEM chunk
+abac_id_t *abac_id_from_chunk(abac_chunk_t chunk);
+
+// load an X.509 private key from a file
+int abac_id_privkey_from_file(abac_id_t *id, char *filename);
+
+// generate an ID
+// returns one of ABAC_SUCCESS or ABAC_GENERATE_* (see top)
+int abac_id_generate(abac_id_t **ret, char *cn, long validity);
+
+// get the SHA1 keyid, pointer is valid for the lifetime of the object
+char *abac_id_keyid(abac_id_t *id);
+
+// get the name of the issuer
+// caller must free the returned string
+char *abac_id_issuer(abac_id_t *id);
+
+// get the DN of the subject
+// caller must free the returned string
+char *abac_id_subject(abac_id_t *id);
+
+// check if the cert is still valid
+int abac_id_still_valid(abac_id_t *id);
+
+// check if the principal cert's keyid is specified
+int abac_id_has_keyid(abac_id_t *id, char *);
+
+// check if the cert is has a private key
+int abac_id_has_privkey(abac_id_t *id);
+
+// get the validity period of the cert
+int abac_id_validity(abac_id_t *id, struct tm *not_before, struct tm *not_after);
+
+// default filename for the cert: ${CN}_ID.pem
+// caller must free the returned string
+char *abac_id_cert_filename(abac_id_t *id);
+
+// write the cert fo an open file pointer
+int abac_id_write_cert(abac_id_t *id, FILE *out);
+
+// default filename for the private key: ${CN}_key.pem
+// caller must free the return value
+char *abac_id_privkey_filename(abac_id_t *id);
+
+// write the private key to a file
+// it is recommended that you open this file mode 0600
+// returns false if there's no private key loaded
+int abac_id_write_privkey(abac_id_t *id, FILE *out);
+
+// get a chunk representing the cert
+// you must free the ptr of the chunk when done
+abac_chunk_t abac_id_cert_chunk(abac_id_t *id);
+
+// dup an ID (increases its refcount)
+abac_id_t *abac_id_dup(abac_id_t *id);
+
+// destroy the id
+// decreases refcount and destroys when it hits 0
+void abac_id_free(abac_id_t *id);
+
+/*
+ * Operations on Attribute
+ */
+//
+// Here's the skinny:
+//  Attribute cert objects don't contain an actual cert until they're baked.
+//  First you construct the object using abac_attribute_create, then you add
+//  subjects to it using abac_attribute_{principal,role,linking_role}.
+//  Finally you bake it. Once you've done that, you can keep it as XML chunk
+//  or write it to a file.
+//
+
+// create an attribute cert
+// validity is in days
+// returns one of CREDDY_SUCCESS or CREDDY_ATTRIBUTE_* (see top)
+int abac_attribute_create(abac_attribute_t **attr, abac_id_t *issuer, char *role, long validity);
+
+// add a head string to the cert
+void abac_attribute_set_head(abac_attribute_t *attr, char *string);
+
+// return the head string of the attribute
+char *abac_attribute_get_head(abac_attribute_t *);
+
+// add a tail role string to the cert
+void abac_attribute_set_tail(abac_attribute_t *attr, char *string);
+
+// return the tail string of the attribute
+char *abac_attribute_get_tail(abac_attribute_t *);
+
+// add a principal subject to the cert
+int abac_attribute_principal(abac_attribute_t *attr, char *keyid);
+
+// add a role subject
+int abac_attribute_role(abac_attribute_t *attr, char *keyid, char *role);
+
+// add a linking role subject
+int abac_attribute_linking_role(abac_attribute_t *attr, char *keyid, char *role, char *linked);
+
+// create the attribute cert once all the subjects have been added
+// can return 0 if there are no subjects or there's a problem building the cert
+int abac_attribute_bake(abac_attribute_t *attr);
+
+// returns true iff the cert's been baked
+int abac_attribute_baked(abac_attribute_t *attr);
+
+// write the cert to a file. returns 0 if the cert hasn't been baked
+int abac_attribute_write(abac_attribute_t *attr, FILE *out);
+
+// get chunked cert
+// returns 0 if the cert isn't baked
+int abac_attribute_cert_chunk(abac_attribute_t *, abac_chunk_t *);
+
+// destroy the cert
+void abac_attribute_free(abac_attribute_t *);
+
+// load a list of attr cert from file (aborts on fail)
+abac_list_t *abac_attribute_certs_from_file(char *);
+
+// load a list of attr cert from chunk (aborts on fail)
+abac_list_t *abac_attribute_certs_from_chunk(abac_chunk_t);
+
+// get the attribute role string
+char *abac_attribute_role_string(abac_attribute_t *attr);
+
+// get the issuer id of an attribute
+abac_id_t *abac_attribute_issuer_id(abac_attribute_t *ptr);
+
+// get the validity period of the attribute cert
+int abac_attribute_validity(abac_attribute_t *attr, struct tm *not_before, struct tm *not_after);
+
+// return the principal from an attribute's role string
+// callee must free the space
+char *abac_attribute_get_principal(abac_attribute_t *attr);
+
+// check if the attribute cert is still valid
+int abac_attribute_still_valid(abac_attribute_t *attr);
+
+
+/*
  * Error codes for loading certificates.
  */
@@ -75,4 +229,21 @@
 #define ABAC_CERT_BAD_SIG           -2  // invalid signature
 #define ABAC_CERT_MISSING_ISSUER    -3  // missing ID cert that issued the attribute cert
+#define ABAC_CERT_BAD_PRINCIPAL     -4  // Principal of attribute cert issuer has mismatch keyid
+#define ABAC_CERT_INVALID_ISSUER    -5  // Issuer of attribute cert is invalid
+#define ABAC_CERT_SIGNER_NOKEY      -6  // Signer of attribute cert is missing private key
+
+/*
+ * Error codes for IDs and Attributes
+ */
+#define ABAC_SUCCESS                          0
+#define ABAC_FAILURE                          1 /* catch all */
+#define ABAC_GENERATE_INVALID_CN             -1
+#define ABAC_GENERATE_INVALID_VALIDITY       -2
+#define ABAC_ATTRIBUTE_ISSUER_NOKEY          -3
+#define ABAC_ATTRIBUTE_INVALID_ROLE          -4
+#define ABAC_ATTRIBUTE_INVALID_VALIDITY      -5
+#define ABAC_ATTRIBUTE_INVALID_ISSUER        -6
+
+
 
 #endif /* __ABAC_H__ */
